#ifndef TCP_TUNNEL_H
#define TCP_TUNNEL_H

#define VERSION "0.2"

#define OK 0
#define KO 1

#define SIZE 512

#define LOCAL_PORT_OPTION  'a'
#define REMOTE_PORT_OPTION 'b'
#define REMOTE_HOST_OPTION 'c'
#define STAY_ALIVE_OPTION  'd'
#define HELP_OPTION        'e'
#define VERSION_OPTION     'f'
#define LOG_TO_STDOUT      'g'

#define PATH_SEPARATOR     '/'

const char *exec_name;

void print_help     (void);
void print_helpinfo (void);
void print_usage    (void);
void print_version  (void);
void print_missing  (const char *message);

void get_commandline_param (int argc, char *argv[]);
void set_option (char **option, char *value);

int build_server (void);
int wait_for_clients (void);
int build_tunnel (void);
int use_tunnel (void);

char *get_current_timestamp (void);

struct struct_settings {
        unsigned int local_port    : 1;
        unsigned int remote_host   : 1;
        unsigned int remote_port   : 1;
        unsigned int stay_alive    : 1;
	unsigned int log_to_stdout : 1;
};

struct struct_options {
        char *local_port;

        char *remote_host;
        char *remote_port;
};

struct struct_rc {
	unsigned int server_socket;
	unsigned int client_socket;
	unsigned int remote_socket;

	struct sockaddr_in server_addr;
	struct sockaddr_in client_addr;
	struct sockaddr_in remote_addr;

	struct hostent *remote_host;
};

#endif
